unit DemoUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, PrpGrid, Mask, Filectrl;

type
  TPropertyGridForm = class(TForm)
    Add: TButton;
    Change: TButton;
    Delete: TButton;
    ComboBox1: TComboBox;
    Label1: TLabel;
    ShowCheckColumn: TCheckBox;
    goTitleInOptions: TCheckBox;
    Panel1: TPanel;
    PropertyGrid1: TPropertyGrid;
    Bevel1: TBevel;
    Exit: TButton;
    OpenDialog1: TOpenDialog;
    Clear: TButton;
    procedure ComboBox1Change(Sender: TObject);
    procedure AddClick(Sender: TObject);
    procedure ChangeClick(Sender: TObject);
    procedure DeleteClick(Sender: TObject);
    procedure PropertyGrid1EditButtonClick(Sender: TObject; ARow: Integer);
    procedure ShowCheckColumnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure goTitleInOptionsClick(Sender: TObject);
    procedure ExitClick(Sender: TObject);
    procedure PropertyGrid1CheckBoxClick(Sender: TObject; ARow: Integer);
    procedure ClearClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PropertyGridForm: TPropertyGridForm;

implementation

{$R *.DFM}

procedure TPropertyGridForm.ComboBox1Change(Sender: TObject);
begin
  case ComboBox1.ItemIndex of
    0:PropertyGrid1.EditFrameStyle:=efFlat;
    1:PropertyGrid1.EditFrameStyle:=efFramed;
    2:PropertyGrid1.EditFrameStyle:=efThinFramed;
  end;
end;

procedure TPropertyGridForm.AddClick(Sender: TObject);
begin
  PropertyGrid1.AddPropertyRow('New Property','(new object)',emEllipsis);
  with PropertyGrid1 do
    PropValues[Pred(RowCount)].Tag:=3;
end;

procedure TPropertyGridForm.ChangeClick(Sender: TObject);
begin
  PropertyGrid1.ChangePropertyRow(PropertyGrid1.Row,'Change Property','Second',emPickList);
  with PropertyGrid1 do
    PropValues[Row].PickList.Text:='First'#$D#$A'Second'#$D#$A'Third';
end;

procedure TPropertyGridForm.DeleteClick(Sender: TObject);
begin
  with PropertyGrid1 do
    begin
      DeletePropertyRow(Row);
//      if PropValues[Row].EditMode = emNoEdit then Row := Row - 1;
    end; 
end;

procedure TPropertyGridForm.PropertyGrid1EditButtonClick(Sender: TObject; ARow: Integer);
var Dir:String;
begin
  with PropertyGrid1.PropValues[ARow] do
    case Tag of
      1: begin
           if (OpenDialog1.Execute) then
             PropertyValue := OpenDialog1.FileName;
         end;
      2: begin
           Dir := ExtractFilePath(ParamStr(0));
           if SelectDirectory(Dir,[sdAllowCreate, sdPerformCreate, sdPrompt],0) then
             PropertyValue := Dir;
         end;
    else
      ShowMessage('EventHandler not defined!');
    end;
end;

procedure TPropertyGridForm.ShowCheckColumnClick(Sender: TObject);
begin
  PropertyGrid1.ShowCheckColumn := ShowCheckColumn.Checked;
  with PropertyGrid1 do
    if ShowCheckColumn then Row := 1;
end;

procedure TPropertyGridForm.FormCreate(Sender: TObject);
begin
  ComboBox1.ItemIndex:=1;
  PropertyGrid1.Row := 1;
end;

procedure TPropertyGridForm.goTitleInOptionsClick(Sender: TObject);
begin
  if goTitleInOptions.Checked then
    PropertyGrid1.Options := PropertyGrid1.Options + [goTitle]
  else
    begin
      PropertyGrid1.Options := PropertyGrid1.Options - [goTitle];
      PropertyGrid1.Row := 1;
    end;
end;

procedure TPropertyGridForm.ExitClick(Sender: TObject);
begin
  Close;
end;

procedure TPropertyGridForm.PropertyGrid1CheckBoxClick(Sender: TObject;
  ARow: Integer);
begin
  SHowMessage('CheckBoxClick in Row - '+IntToStr(Arow));
end;

procedure TPropertyGridForm.ClearClick(Sender: TObject);
begin
  Propertygrid1.PropValues.Clear;
end;

end.
